package SetExec;

import java.io.*;
import java.util.*;
import ApiSet.*;
import NewObjects.*;

/* 
   Un insieme finito e' un tipo di dato strutturato, 'a set, della forma {x1,...,xn}, per 
   n>=0, a componenti xi omogenei e contenente al piu' un'occorrenza di uno stesso valore,
   i.e. xi=xj iff i=j. 
   I valori 'a set sono valori Mutable, sui quali possiamo operare mediante le sole opera-
   zioni introdotte in ApiSet<A>. In aggiunta, ogni ADT che implementi APISet<A> provvede-
   ra' a definire un costruttore per insiemi vuoti e il metodo toString per la presentazio-
   ne del valore rappresentato da this. Sia Set1<A> un ADT per tale API. Si chiede di:
   (1) Mostrare la definizione di {\tt APISet<A>};
   (2) Estendere, in una nuova classe {\tt SetIS<A>}, con il metodo {\tt is}, i valori di 
   	   {\tt APISet<A>}, implementati in {\tt Set1}.\ Il metodo {\tt is}, applicato ad un 
   	   oggetto di tipo {\tt A}, calcola true se tale oggetto \`e contenuto in this. Calco-
   	   la false, altrimenti. \\
 	   Si fornisca la {\tt SetIS<A>} completando e compilando gli opportuni files nel List-
 	   ing allegato.
   (3) Si completi, compili ed esegua il file {\tt MainSet.java} con un caso di uso.
 */

public class MainSet{
    public static void main(String[] args){
        APISet<MuInt1> s1 = new Set1<MuInt1>();
        MuInt1 n1 = new MuInt1(5);
        MuInt1 n2 = new MuInt1(12);
        MuInt1 n3 = new MuInt1(5);        
        Vector<MuInt1> list1 = new Vector<MuInt1>();
        list1.add(n1);
        list1.add(n2);
        list1.add(n3);
        s1.addAll(list1);
        System.out.println(s1);
        //usiamo l'estensione
        APISet<MuInt1> s2 = new SetIS<MuInt1>();
        s2.addAll(list1);        
        System.out.println(s2);
        MuInt1 n4 = new MuInt1(5);
        System.out.println("is n4 in s2? " + ((SetIS<MuInt1>)s2).is(n4));                
    }
}

/*
host-131-114-218-120:Listing marcob$ javac SetIS.java -d .
host-131-114-218-120:Listing marcob$ javac MainSet.java -d .
host-131-114-218-120:Listing marcob$ java SetExec/MainSet
{[5], [12], [5]}
{[5], [12], [5]}
is n4 in s2? false
host-131-114-218-120:Listing marcob$ 
*/